<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.keypeople_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/person/keypeople";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          labelWidth: 120,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          addBtn: false,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "基本表id",
              prop: "parentId",
              hide: true,
              display: false,
              rules: [{
                required: false,
                message: "请输入基本表id",
                trigger: "blur"
              }]
            },
            {
              label:'姓名',
              prop:'name',
              search:true,
              editDisplay:false
            },
            {
              label: "重点人员类型",
              prop: "type",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=key-type",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              type: "select",
              multiple: true,
              dataType:'string',
              rules: [{
                required: true,
                message: "请选择重点人员类型",
                trigger: "blur"
              }]
            },
            {
              label: "是否需要援助",
              prop: "assistance",
              type: 'select',
              dataType: 'number',
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=assistance",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              rules: [{
                required: false,
                message: "是否需要援助",
                trigger: "blur"
              }]
            },
            {
              label: "是否需要走访",
              prop: "visit",
              type: 'select',
              dataType: 'number',
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=visit",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              rules: [{
                required: false,
                message: "是否需要走访",
                trigger: "blur"
              }]
            },
            {
              label: "访问人员",
              prop: "visitPerson",
              rules: [{
                required: false,
                message: "请输入访问人员",
                trigger: "blur"
              }]
            },
            // {
            //   label: "所属社区",
            //   prop: "agencyId",
            //   search: true,
            //   cascaderItem: ['residentialId'],
            //   type: "select",
            //   remote: true,
            //   dicUrl: "/api/cyzh-community/agency/list",
            //   dicFormatter:(res)=>{
            //     return res.data.records;//返回字典的层级结构
            //   },
            //   props: {
            //     label: "name",
            //     value: "id"
            //   },
            //   rules: [{
            //     required: true,
            //     message: "请选择所属社区",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "所属小区",
            //   prop: "residentialId",
            //   type: "select",
            //   search: true,
            //   cascaderItem: ['buildingId'],
            //   dicUrl: "/api/cyzh-community/residential/list?agencyId={{key}}",
            //   dicFormatter:(res)=>{
            //     return res.data.records;//返回字典的层级结构
            //   },
            //   // dicFlag: false,
            //   filterable: true,
            //   props: {
            //     label: "name",
            //     value: "id"
            //   },
            //   rules: [{
            //     required: true,
            //     message: "请选择所属小区",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "所属楼栋",
            //   prop: "buildingId",
            //   hide: true,
            //   type: "select",
            //   cascaderItem: ['unitId'],
            //   dicUrl: `/api/cyzh-community/building/list?residentialId={{key}}`,
            //   dicFormatter:(res)=>{
            //     return res.data.records;//返回字典的层级结构
            //   },
            //   // dicFlag: false,
            //   filterable: true,
            //   props: {
            //     label: "name",
            //     value: "id"
            //   },
            //   rules: [{
            //     required: true,
            //     message: "请输入楼栋Id",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "所属单元",
            //   prop: "unitId",
            //   type: "select",
            //   hide: true,
            //   cascaderItem: ['floorId'],
            //   dicUrl: "/api/cyzh-community/unit/list?buildingId={{key}}",
            //   dicFormatter:(res)=>{
            //     return res.data.records;//返回字典的层级结构
            //   },
            //   // dicFlag: false,
            //   filterable: true,
            //   props: {
            //     label: "name",
            //     value: "id"
            //   },
            //   rules: [{
            //     required: true,
            //     message: "请输入单元Id",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "所属楼层",
            //   prop: "floorId",
            //   hide: true,
            //   type: "select",
            //   cascaderItem: ['roomId'],
            //   dicUrl: "/api/cyzh-community/floor/list?unitId={{key}}",
            //   dicFormatter:(res)=>{
            //     return res.data.records;//返回字典的层级结构
            //   },
            //   // dicFlag: false,
            //   filterable: true,
            //   props: {
            //     label: "name",
            //     value: "id"
            //   },
            //   rules: [{
            //     required: true,
            //     message: "请输入楼层Id",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "所属房间",
            //   prop: "roomId",
            //   hide: true,
            //   type: "select",
            //   dicUrl: "/api/cyzh-community/room/list?floorId={{key}}",
            //   dicFormatter:(res)=>{
            //     return res.data.records;//返回字典的层级结构
            //   },
            //   // dicFlag: false,
            //   filterable: true,
            //   props: {
            //     label: "name",
            //     value: "id"
            //   },
            //   rules: [{
            //     required: true,
            //     message: "请输入房间Id",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "备注",
            //   prop: "remark",
            //   type: 'textarea',
            //   rules: [{
            //     required: false,
            //     message: "请输入备注",
            //     trigger: "blur"
            //   }]
            // },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.keypeople_add, false),
          viewBtn: this.vaildData(this.permission.keypeople_view, false),
          delBtn: this.vaildData(this.permission.keypeople_delete, false),
          editBtn: this.vaildData(this.permission.keypeople_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
